<!--
  This file is part of Dezrann <http://www.dezrann.net>
  Copyright (C) 2016-2021 by Algomus Team at CRIStAL (UMR CNRS 9189, Université Lille),
  in collaboration with MIS (UPJV, Amiens) and LITIS (Université de Rouen).

  Dezrann is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dezrann is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dezrann.  If not, see <https://www.gnu.org/licenses/>.
-->


<link rel="import" href="../../bower_components/polymer/polymer-element.html">
<link rel="import" href="../../bower_components/app-layout/app-toolbar/app-toolbar.html">
<link rel="import" href="../../bower_components/app-route/app-location.html">

<link rel="import" href="../../bower_components/dez-music-canvas/dez-music-canvas.html">
<link rel="import" href="../../bower_components/dez-music-canvas/dez-label-editor.html">
<link rel="import" href="../../bower_components/dez-label-bar/dez-edit-bar.html">
<link rel="import" href="../../bower_components/dez-corpus/dez-corpus.html">
<link rel="import" href="../../bower_components/dez-analysis/dez-analysis.html">
<link rel="import" href="../../bower_components/dez-debug/dez-debug.html">

<link rel="import" href="dez-config.html">
<link rel="import" href="dez-about.html">
<link rel="import" href="dez-warning.html">
<link rel="import" href="dez-auth.html">
<link rel="import" href="dez-analysis-controls.html">
<link rel="import" href="dez-confirm-changes.html">
<link rel="import" href="dez-audio-player.html">
<link rel="import" href="dez-sources-selector.html">
<link rel="import" href="dez-piece-title.html">
<link rel="import" href="dez-piece.html">
<link rel="import" href="dez-number-row.html">

<dom-module id="dezrann-app">
  <template>
    <style>

    :host {
        height: 100vh;
        display: flex;
        flex-direction: column;
    }

    dez-music-canvas {
        flex-grow: 1;
    }

    app-toolbar {
      background-color: #607D8B;
      color: #fff;
      font-family: 'Roboto', 'Noto', sans-serif;
    }

    dez-analysis-controls {
        min-width: 400px;
        flex: 1 0;
        align-self: center;
    }

    @media (max-width: 700px) {
      .hidden-xxs {
        display: none;
      }

      dez-analysis-controls {
        min-width: 240px;
      }
    }

    @media (max-width: 1024px) {
      .hidden-xs {
        display: none;
      }
    }

    @media (max-width: 1280px) {
      .hidden-md {
        display: none;
      }
    }

    *[hidden] { display: none; }

    .view-toggle-button {
      position: absolute;
      top: 60px;
      right: 0;
      color: #607d8b;
    }

    </style>

    <dez-config id="config"></dez-config>
    <app-location id="location" route="{{route}}" use-hash-as-path></app-location>
    <dez-analysis id="analysis" jwt="[[_jwt]]"></dez-analysis>
    <dez-piece id="piece" corpus-location="[[location]]" jwt="[[_jwt]]"></dez-piece>
    <dez-warning id="warningDialog"></dez-warning>

    <app-toolbar>

      <dez-corpus id="corpus"
        location="[[location]]"
        current="[[_corpus]][[_pieceId]]"
        jwt="[[_jwt]]"
        prefix="[[_prefix]]">
      </dez-corpus>

      <dez-about class="hidden-xs"></dez-about>

      <dez-piece-title id="pieceTitle" class="hidden-xs"></dez-piece-title>

      <dez-analysis-controls id="analysisControls"
        piece-id=[[_pieceId]]
        location="[[_analysesLocation]]"
        jwt="[[_jwt]]"
        collab-on="[[collabOn]]">
      </dez-analysis-controls>

      <dez-confirm-changes id="changesWillBeLostDialog" ></dez-confirm-changes>

      <dez-sources-selector id="sourcesSelector"></dez-sources-selector>

      <template is="dom-if" if=[[_audioFile]] on-dom-change="_initAudio">
       <dez-audio-player id="audioPlayer" src="[[_audioFile]]"></dez-audio-player>
      </template>

      <dez-auth id="login" auth-server="[[_authServer]]" jwt="{{_jwt}}"></dez-auth>

    </app-toolbar>


    <template is="dom-if" if="[[!_isSecondCanvasOn]]">
      <paper-icon-button
        class="view-toggle-button"
        icon="view-agenda"
        title="add a second view of the piece"
        on-click="_showSecondView"
        role="button" tabindex="0" aria-disabled="false"></paper-icon-button>
    </template>
    <template is="dom-if" if="[[_isSecondCanvasOn]]">
      <paper-icon-button
        class="view-toggle-button"
        icon="view-day"
        title="remove the second view"
        on-click="_hideSecondView"
        role="button" tabindex="0" aria-disabled="false"></paper-icon-button>
    </template>

    <dez-music-canvas
      id="analysisView"
      zoom="[[_zoom]]"
      jwt="[[_jwt]]"
      last-offset="[[lastOffset]]"
      current-date="{{_currentTime}}"
      audio-synchro="[[_synchroUrl]]"
      onset="{{_onset}}"
    ></dez-music-canvas>

    <dez-music-canvas
      id="analysisView2"
      zoom="[[_zoom]]"
      jwt="[[_jwt]]"
      last-offset="[[lastOffset]]"
      current-date="{{_currentTime}}"
      audio-synchro="[[_synchroUrl]]"
      hidden$="[[!_isSecondCanvasOn]]"
    ></dez-music-canvas>

    <template is="dom-if" if="[[labelBarOn]]" on-dom-change="_initRapidEditor">
      <dez-edit-bar id="editBar"></dez-edit-bar>
    </template>
    <template is="dom-if" if="[[!labelBarOn]]" on-dom-change="_initEditor">
      <dez-label-editor id="editor"></dez-label-editor>
    </template>

    <iron-a11y-keys
        id="a11y"
        target="[[target]]"
        keys="right"
        on-keys-pressed="_handleKeyNext">
    </iron-a11y-keys>

    <iron-a11y-keys
        id="a11y"
        target="[[target]]"
        keys="left"
        on-keys-pressed="_handleKeyPrev">
    </iron-a11y-keys>

    <dez-number-row id="numberRow"/>

    <template is="dom-if" if=[[_debug]] on-dom-change="_initDebug">
        <dez-debug id="debug"></dez-debug>
    </template>

  </template>

  <script>

  class DezrannApp extends Polymer.Element {

      static get is() { return 'dezrann-app'; }

      static get properties() {
          return {
              location : String,
              labelBarOn : {
                type : Boolean,
                value : false
              },
              collabOn : {
                type : Boolean,
                value : false
              }
          }
      }

      static get observers() {
          return ['_routeChanged(route.*)']
      }

      _updateRoute () {
        let debugKey = this._debug?"debug":"";
        let onset = this._onset || 0;
        this.set('route.path', debugKey + "/" + this._corpus + this._pieceId + "#" + toMeasureRounded(onset));
      }

      _extractUrl () {
        let re = /http[s]?:\/\/[^\/]+[\/]?([^#]*)[#]?([a-z]*)[\/]?([^#]*)[#]?([0-9]*)$/
        let match = re.exec(this.baseURI)
        return {
          htmlFile : match[1] || "",
          mode : match[2] || "",
          id : match[3] || "bwv847",
          onset : parseMeasureFrac(match[4] || '0')
        }
      }

      _updatePieceId (update) {
        if (this.$.analysis.backupNeeded) {
          this.$.changesWillBeLostDialog.open(
            () => update(),
            () => this._updateRoute()
          )
        } else {
          update()
        }
      }

      _routeChanged(event) {
        let url = this._extractUrl()
        if (url.id != this._corpus + this._pieceId) {
          this._updatePieceId(() => this.$.piece.pid = url.id)
        }
        this._debug = url.mode == "debug"
        this._prefix = '/' + url.htmlFile + '#' + url.mode + '/'
        // If no onset-changed events was ever received, or if the url onset change is bigger than 6
        if (this._onset == undefined || Math.abs(url.onset - this._onset) > 6) {
          this._onset = url.onset;
          // if music canvas was loaded
          if (this.$.analysisView) {
            // Start animation to loaded onset
            this.$.analysisView.setOnsetTarget(url.onset);
          }
        }
      }

      _setEditor (piece) {
        if (piece['editor'] != undefined && piece['editor'] == 'dez-edit-bar') {
          if (this.labelBarOn) { // bar already present. Only reinit button
            this._initBarButtons()
          } else { // editor change to bar editor (dom changed) => complet bar init
            this.labelBarOn = true
          }
        } else {
          this.labelBarOn = false
          this.shadowRoot.querySelector('#editor').timeSignature = {
            numerator: parseInt(piece['time-signature'].split('/')[0]) || 4,
            denominator: parseInt(piece['time-signature'].split('/')[1]) || 4,
            upbeat: parseFloat(piece['time-signature-upbeat']) || 0
          }
        }
      }

      async ready () {
          super.ready();
          this.$.config.addEventListener('config-ready', e => {
            if (this.location == undefined) {
              // Use the value of location in config.json
              // Modifying location :
              // - set the ressources location from dezrann.net (png, mp3, pos...)
              // - loads the corpus from ws
              // - loads the piece from ws
              this.location = e.detail.location
            }
            this.$.login.visible = e.detail.displayLogin
            this._authServer = e.detail.authServer
            this.$.analysisControls.collabServer = e.detail.collabServer
          })
          this.$.config.addEventListener('config-error', e => {
            console.log("config error");
          })
          this.$.piece.addEventListener('piece-error', e => {

            // If WS returns unauthorized (401), try to display login popup
            if (e.detail.error.code === "wsUnauthorizedError") {
              if (this.$.login.isLoggedIn) {
                this.$.warningDialog.open("wsUnauthorizedError");
                // Redirect to default piece
                this.set("route.path","");
              } else {
                this.$.login.openLoginDialog();
              }
            }
            // If piece doesn't exist (404/wsMissingError), let dez-piece redirect to default
            else if (e.detail.error.code === "wsMissingError") {
              this.$.warningDialog.open("wsMissingError");
              // Redirect to default piece
              this.set('route.path',"");
            }
            // If unreachable (502/wsUnreachabledError) 
            else if (e.detail.error.code === "wsUnreachabledError") {
              // Hide login button
              this.$.login.visible = false
              // Display default error (service down)
              this.$.warningDialog.open("wsUnreachabledError");
            }
          })
          this.$.piece.addEventListener('piece-ready', e => {
            this.$.analysisView.resetView();
            this.$.analysisView2.resetView();
            this._currentTime = undefined;
            this.$.login.visible = !this.$.piece.wsUnreachabled
            let piece = e.detail.piece.infos
            this._audioFile = this.$.piece.firstAudio.file
            this._synchroUrl = this.$.piece.firstAudio.synchro;
            this._lastOffset = piece['last-offset'];
            this._setEditor(piece)
            this._pieceId = piece.id;
            this._corpus = piece.corpus;
            document.title = piece.title + ", " + piece.composer + " - Dezrann"
            this.$.pieceTitle.piece = piece
            this.$.analysisControls.piece = piece
            this.$.sourcesSelector.sources = piece.sources
            this.$.analysis.backupNeeded = false
            this.$.analysis.erase()
            this.$.analysis.pieceName = e.detail.piece.location
            this._updateRoute();
          })
          this.$.analysisView.addEventListener('onset-changed', e => this._updateRoute())
          this.$.analysisView.addEventListener('view-ready', e => {
            this._analysesLocation = this.$.piece.analysesLocation
          })
          this.$.sourcesSelector.addEventListener('new-source-selected', event => {
            this.$.analysisView.source = event.detail.source
            this.$.analysisView2.source = event.detail.source
          })
          this.$.analysisView.analysis = this.$.analysis
          this.$.analysisView2.analysis = this.$.analysis
          this.$.analysisControls.analysis = this.$.analysis
          this.$.analysisControls.confirmDialog = this.$.changesWillBeLostDialog
          this._setSecondViewVisibility(false);
      }

      _initBarButtons () {
        let editBar = this.shadowRoot.querySelector('#editBar')
        let analysis =  this.$.analysis
        let labelTypes = analysis.labelTypes
        let initTagsNames = ["Refrain", "Couplet", "Voix aiguës"]
        labelTypes.neededTags = initTagsNames
        editBar.tags = initTagsNames.map(tag => labelTypes.coloredTag(tag, "Edmus"))
        editBar.activeTag = editBar.tags[0].name
        editBar.selectedInput = undefined
        analysis.currentLabelModel = {type: 'Edmus',tag: editBar.activeTag }
      }

      _initBarEventListeners () {
        let editBar = this.shadowRoot.querySelector('#editBar')
        let analysis =  this.$.analysis
        let labelTypes = analysis.labelTypes
        const numberRow = this.$.numberRow;
        analysis.addEventListener('analysis-loaded', () => {
          let usedTags = analysis.usedTags
          if (usedTags.length > 0) {
            let names = usedTags.sort((a,b) => b.occurences - a.occurences)
            .slice(0,10)
            .map(tag => tag.name)
            editBar.tags = names.map(name => labelTypes.coloredTag(name, "Edmus"))
            editBar.activeTag = editBar.tags[0].name
            labelTypes.neededTags = names
          }
        })
        analysis.addEventListener('label-selected', event => {
          editBar.activeTag = event.detail.label.tag
          editBar.selectedInput = event.detail.label.tag
        })
        editBar.addEventListener('tags-list-changed', (event) => {
          let names = event.detail.names
          labelTypes.neededTags = names
          // add new tags
          names.filter(
            name => editBar.tags.filter(tag => tag.name == name).length == 0
          ).forEach(name => editBar.tags.push(labelTypes.coloredTag(name, "Edmus")))
          // delete tags
          editBar.tags = editBar.tags.filter(tag => names.includes(tag.name))
        })
        editBar.addEventListener('tag-btn-tap', () => {
          analysis.currentLabelModel = {type: 'Edmus',tag: editBar.activeTag }
          if (this._audioPlayer && this._audioPlayer.playing) {
            let onset = this.$.analysisView.synchro.toOnset(this._audioPlayer.currentTime)
            analysis.addLabel (Object.assign(analysis.currentLabelModel, {
              duration : 3,
              start : onset
            }))
          }
        })

        // Number row label creation
        // Active keys
        const numberRowActive = {};

        // Create label on keydown
        numberRow.addEventListener('number-row-keydown', (event) => {
          const index = event.detail.position;
          if (!editBar.tags[index] || !editBar.tags[index].name) {
            console.log('No label for pos ', index);
            return;
          }
          // If keydown was not emitted, previous label might still be expanded 
          if (numberRowActive[index]) return;

          analysis.currentLabelModel = {type: 'Edmus', tag: editBar.tags[index].name }
          if (this._audioPlayer && this._audioPlayer.playing) {
            let onset = this.$.analysisView.synchro.toOnset(this._audioPlayer.currentTime)
            numberRowActive[index] = analysis.addLabel (Object.assign(analysis.currentLabelModel, {
              duration : 0,
              start : onset
            }))
          }
        });
        // Expand label on key repeat
        numberRow.addEventListener('number-row-repeat', (event) => {
          const index = event.detail.position;
          if (numberRowActive[index] && this._audioPlayer && this._audioPlayer.playing) {
              const label = numberRowActive[index];
              let onset = label.start;
              let outset = this.$.analysisView.synchro.toOnset(this._audioPlayer.currentTime);
              label.genericDuration = Math.abs(outset - onset);
              console.log(onset, outset, label.duration);

              analysis.setLabel(label, this.id);
          }
        });
        // Forget label on key up 
        numberRow.addEventListener('number-row-keyup', (event) => {
          numberRowActive[event.detail.position] = null;
        });

        // New labels for label bar
        editBar.addEventListener('plus-btn-tap', () => {
          editBar.tags.push(labelTypes.coloredTag(editBar.selectedInput, "Edmus"))
          editBar.tags = editBar.tags.filter(v=>true)
          labelTypes.neededTags = editBar.tags.map(t => t.name)
        })
        editBar.addEventListener('selected-input-changed', () => {
          if (editBar.selectedInput != undefined) {
            analysis.setLabel({
              'id': analysis.selectedLabel.id,
              'tag': editBar.selectedInput
            })
          }
        })
      }

      _initRapidEditor () {
        this._initBarButtons()
        this._initBarEventListeners()
      }

      _initAudio () {
        let audioPlayer = this.shadowRoot.querySelector('#audioPlayer')
        audioPlayer.addEventListener('new-step-forward', () => {
          this._currentTime = this._audioPlayer.currentTime;
          let onset = this.$.analysisView.synchro.toOnset(this._audioPlayer.currentTime)
          this._audioPlayer.currentMeasure = 'm' + toMeasureRounded(onset)
        })
        audioPlayer.addEventListener('rewind-pressed', () => {
          this._currentTime = 0;
        })
        this.$.analysisView.addEventListener('current-date-changed', event => {
          this._audioPlayer.currentTime = this.$.analysisView.currentDate
        })
        this._audioPlayer = audioPlayer
      }

      _initEditor () {
        const editor = this.shadowRoot.querySelector('#editor');
        
        editor.analysis = this.$.analysis;

        editor.addEventListener('next-type-button-pressed', () => this._handleKeyNextType())
        editor.addEventListener('prev-type-button-pressed', () => this._handleKeyPrevType())
      }

      _initDebug () {
        this.shadowRoot.querySelector('#debug').analysis = this.$.analysis
      }

      _selectLabel(label) {
        if (!label) return;

        this.$.analysis.selectLabel(label.id, this.id);
        // Start animation to focus on selected label
        this.$.analysisView.scrollRangeInView(label.start, label.start + label.ioi);
      }

      _hideSecondView() { this._setSecondViewVisibility(false) }
      _showSecondView() { this._setSecondViewVisibility(true) }

      _setSecondViewVisibility(value) {
        this._zoom = value ? 0.7 : 1;
        this._isSecondCanvasOn = value;
      }

      _handleKeyNext (event) {
        this._selectLabel(this.$.analysis.getNext());
      }

      _handleKeyPrev (event) {
        this._selectLabel(this.$.analysis.getPrev());
      }

      _handleKeyNextType (event) {
        this._selectLabel(this.$.analysis.getNextOfType());
      }

      _handleKeyPrevType (event) {
        this._selectLabel(this.$.analysis.getPrevOfType());
      }

  }

  window.customElements.define(DezrannApp.is, DezrannApp);

  </script>
</dom-module>
